#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>

class SynchObj {
	int arrivati;
	sem_t block;
	sem_t mutex;
	int nthread;
public:
	SynchObj(int n) {
		nthread = n;
		arrivati = 0;
		sem_init(&block, 0, 0);
		sem_init(&mutex, 0, 1);
	}

	void synch() 
	{
		sem_wait(&mutex);
		arrivati++;
		if (arrivati < nthread) {
			sem_post(&mutex);
			sem_wait(&block);
		}
		else {
			arrivati = 0;
			sem_post(&mutex);
			for (int i=0; i<nthread - 1; i++) sem_post(&block);
		}
	}
};


void *thread_body(void *arg)
{
  SynchObj *s = (SynchObj *)arg;

  printf("Before the synchronization point...\n");

  s->synch();

  printf("After the synchronization point!\n");
}

int main(int argc, char *argv[])
{
  pthread_t *array;
  int i;

  if (argc < 2) {
    printf("Usage: %s <nthreads>\n", argv[0]);
    exit(0);
  }
  int n = atoi(argv[1]);
  printf("Example with %d threads\n", n);
  
  array = new pthread_t[n];

  SynchObj my_synch(n);

  for(i=0; i<n; i++) 
    pthread_create(&array[i], 0, thread_body, (void *)(&my_synch));
  
  for (i=0; i<n; i++) 
    pthread_join(array[i], 0);
}
