#include <pthread.h>
#include <iostream>
#include <cstdlib>

using namespace std;

class Shared {
    pthread_mutex_t m;
    pthread_cond_t br;
    pthread_cond_t bw;

    int nr;  // lettori che stanno leggendo
    bool w;  // true se uno scrittore sta scrivendo    

    int nbw;
    int nbr;

public:
    Shared();

    void write_begin();
    void write_end();
    void read_begin();
    void read_end();
};

Shared::Shared()
{
    pthread_mutex_init(&m, 0);
    pthread_cond_init(&br, 0);
    pthread_cond_init(&bw, 0);
    nr = 0;
    w = false;
    nbr = 0;
    nbw = 0;
}

void Shared::read_begin()
{
    pthread_mutex_lock(&m);

    if (w || nbw > 0) {
        do {
            nbr ++;
            pthread_cond_wait(&br, &m);
            nbr--;
        } while (w);
    }

    nr++;

    pthread_mutex_unlock(&m);
}

void Shared::read_end()
{
    pthread_mutex_lock(&m);

    nr--;

    if (nr == 0) pthread_cond_signal(&bw);
    
    pthread_mutex_unlock(&m);
}

void Shared::write_begin()
{
    pthread_mutex_lock(&m);

    while (nr > 0 || w) {
        nbw++;
        pthread_cond_wait(&bw, &m);
        nbw--;
    } 

    w = true;

    pthread_mutex_unlock(&m);
}

void Shared::write_end()
{
    pthread_mutex_lock(&m);
    
    w = false;
    
    if (nbr > 0) pthread_cond_broadcast(&br);
    else pthread_cond_signal(&bw);
    
    pthread_mutex_unlock(&m);
}


Shared sh;



void *reader(void *arg)
{
    int index = *((int *)arg);

    while (1) {
        sleep(rand()%4 + 1);
        cout << "Reader " << index << " requests" << endl;
        sh.read_begin();
        cout << "Reader " << index << " is reading " << endl;
        sleep(2);
        cout << "Reader " << index << " finishes " << endl;
        sh.read_end();
    }
    return 0;
}

void *writer(void *arg)
{
    int index = *((int *)arg);

    while (1) {
        sleep(rand()%4 + 1);
        cout << "Writer " << index << " requests" << endl;
        sh.write_begin();
        cout << "Writer " << index << " is writing " << endl;
        sleep(3);
        cout << "Writer " << index << " finishes " << endl;
        sh.write_end();
    }
    return 0;
}


#define NR   15
#define NW   4

int main()
{
    pthread_t rid[NR];
    pthread_t wid[NW];

    int rind[NR];
    int wind[NR];

    for (int i=0; i<NR; i++) {
        rind[i] = i;
        pthread_create(&rid[i], 0, reader, &rind[i]);
    }

    for (int i=0; i<NW; i++) {
        wind[i] = i;
        pthread_create(&wid[i], 0, writer, &wind[i]);
    }

    while(1);
}
